#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "edit_welcome") 
	{
	&edit_email("pwelcome.eml", "Premium Submission Welcome", "This email is sent after a premium submission has been made.");
	}

if ($q->param('fct') eq "edit_newsub_accept") 
	{
	&edit_email("pacceptance.eml", "New Premium Submission Acceptance Email", "This email is sent to a user when his new premium submission has been approved for inclusion into the directory.");
	}

if ($q->param('fct') eq "edit_submissionreject") 
	{
	&edit_email("prejection.eml", "New Premium Submission Rejection Email", "This email is sent to a user when his new premium submission has not been approved for inclusion into the directory. This might be due to non-payment or other reasons.");
	}

if ($q->param('fct') eq "edit_submissioninform") 
	{
	&edit_email("pinformer.eml", "New Premium Submission Informer Email", "This email is sent to you, to inform you that a new premium submission has been made.");
	}


if ($q->param('fct') eq "month_exp") 
	{
	&edit_email("month_exp.eml", "1 Month Pre-Expiry Email", "This email is sent out 1 month before a premium link expires. This is optional and can be set when in the Control Panel >> Plug-In's >> Premium Link Manager >> Premium Link Settings <BR><strong><a href=\"$admin_url/admin23.cgi?fct=prem_main\">Premium Link Manager</a> &gt;&gt; <a href=\"$admin_url/admin24.cgi?fct=expiry_emails\">Edit Expiry Emails</a>&gt;&gt;1 Month Expiry Email</strong>");
	}

if ($q->param('fct') eq "week_exp") 
	{
	&edit_email("week_exp.eml", "1 Week Pre-Expiry Email", "This email is sent out 1 week before a premium link expires. This is optional and can be set when in the Control Panel >> Plug-In's >> Premium Link Manager >> Premium Link Settings <BR><strong><a href=\"$admin_url/admin23.cgi?fct=prem_main\">Premium Link Manager</a> &gt;&gt; <a href=\"$admin_url/admin24.cgi?fct=expiry_emails\">Edit Expiry Emails</a>&gt;&gt;1 Week Expiry Email</strong>");
	}
	
if ($q->param('fct') eq "expired_email") 
	{
	&edit_email("expired_email.eml", "Expiry Email", "This email is sent out when a premium link has expired. This is optional and can be set when in the Control Panel >> Plug-In's >> Premium Link Manager >>  Premium Link Settings <BR><strong><a href=\"$admin_url/admin23.cgi?fct=prem_main\">Premium Link Manager</a> &gt;&gt; <a href=\"$admin_url/admin24.cgi?fct=expiry_emails\">Edit Expiry Emails</a>&gt;&gt;Expired Email</strong>");
	}
	



if ($q->param('fct') eq "save_email") {&save_email;}

if ($q->param('fct') eq "expiry_emails") {&expiry_emails;}


##################################################################################

sub expiry_emails
{

$hbox = acs::get_heading_box("$web_url/ic_premium.gif", "Edit Expiry Emails", qq[
These emails are sent out to premium link owners when premium links are about to expire or when premium links expired. 
(Note that you have to use a CRON program to send out emails. See the manual for more on this) <BR>
<b><a href="$admin_url/admin23.cgi?fct=prem_main">Premium Link Manager</a> &gt;&gt; Edit Expiry Emails</b>
]); 


print qq[

<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>

<body>

$hbox



<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD"
height="46">
  <tr>
    <td width="99%" bgcolor="#FFFFFF" height="80"><p><strong><a
    href="$admin_url/admin24.cgi?fct=month_exp">1 Month Pre-Expiry Email </a><br>
      </strong>This email is sent out 1 month before a premium link expires. This is optional
      and can be set when in the Control Panel &gt;&gt; Plug-In's &gt;&gt; Premium Link Manager
    &gt;&gt; Premium Link Settings </p></td>
  </tr>
  <tr>
    <td width="99%" bgcolor="#FFFFFF" height="80"><p><strong><a
    href="$admin_url/admin24.cgi?fct=week_exp">1 Week Pre-Expiry Email </a><br>
      </strong>This email is sent out 1 week before a premium link expires. This is optional and
      can be set when in the Control Panel &gt;&gt; Plug-In's &gt;&gt; Premium Link Manager
    &gt;&gt; Premium Link Settings </p></td>
  </tr>
  <tr>
    <td width="99%" bgcolor="#FFFFFF" height="80"><p><strong><a
    href="$admin_url/admin24.cgi?fct=expired_email">Expired Email </a><br>
      </strong>This email is sent out when a premium link has expired. This is optional and can
      be set when in the Control Panel &gt;&gt; Plug-In's &gt;&gt; Premium Link Manager &gt;&gt;
    Premium Link Settings </p></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table>

</body>
</html>


];

}






sub save_email
{
$filename = $q->param('f');

$s = $q->param('s');

if ($q->param('from_name') eq ""){acs::problem_popup("You have to supply a name from whom email is sent.");}
if ($q->param('from_email') eq ""){acs::problem_popup("You have to supply an email address from where email is sent.");}
if ($q->param('email_subject') eq ""){acs::problem_popup("The email needs a subject.");}
if ($q->param('email_message') eq ""){acs::problem_popup("The email needs a message.");}

open (AME, "> $data_dir/$filename");
	print AME $q->param('from_name') . "\n";
	print AME $q->param('from_email') . "\n";
	print AME $q->param('email_subject') . "\n";
	print AME $q->param('email_message') . "\n";
close (AME);

if ($q->param('from') ne "")
	{
	$link = "$admin_url/admin20.cgi";
	}
	else
	{
	$link = "$admin_url/admin23.cgi?fct=prem_main";
	}


########

if ($s eq "s")
	{
	$link = "$admin_url/admin16.cgi";
	}


if ($q->param('expemails') eq "true")
	{
	$link =  "$admin_url/admin24.cgi?fct=expiry_emails";
	}



$hbox = acs::get_heading_box("$web_url/ic_email3.gif", "Email Saved", qq[
<a href="$admin_url/admin16.cgi">Click here to continue.</a>
]); 


print <<END_OF_SV;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox


</body>
</html>

END_OF_SV

}





sub edit_email
{

my ($filename, $heading, $helptext) = @_;



$s = $q->param('s');


($extradfk) = acs::get_extra_vars;
if ($extradfk ne ""){$extradfk = "<font color=\"#8080FF\"><b>Listed below is extra field/key variables that may be used with this email.</b><br><br></b>$extradfk<b></font>";}


$emailmsg = acs::get_file_contents("$data_dir/$filename");

@elines = split (/\n/, $emailmsg);

$from_name = $elines[0];
$from_email = $elines[1];
$email_subject = $elines[2];

$lnc = 0;
foreach $line (@elines)
	{
	if ($lnc > 2)
		{
		$email_message = $email_message . $line . "\n";
		}
	$lnc++;
	}

$from = $q->param('from');


if ($filename eq "pacceptance.eml")
	{
	$rating_code = "<b>%%rating_code_url%%</b><br>This is replaced by a URL that provides the user with instructions on adding a rating box to his/her web site.";
	}
	

if ($filename eq "pinformer.eml")
	{
	$fromnm = "To Email:";
	$instr = "The 'informer' email will be sent to this address.";
	}
	else
	{
	$fromnm = "From Name:";	
	}



if (($filename eq "month_exp.eml") or ($filename eq "week_exp.eml") or ($filename eq "expired_email.eml"))
	{
	$exp_email_crit = qq[<input type="hidden" name="expemails" value="true">];
	}


$hbox = acs::get_heading_box("$web_url/ic_email3.gif", "$heading", qq[
$helptext
<BR><a href="$admin_url/admin16.cgi"><b>Go Back</b></a>
]); 



$helpb = acs::quick_help("Variables Available For Use In This Email ",qq[

<p align="left"><strong>%%title%% <br>
</strong>The title of the link. </p>

<p align="left"><strong>%%description%% </strong><br>
The description of the link. </p>

<p align="left"><strong>%%url%% <br>
</strong>The url of the link. </p>

<p align="left"><strong>%%keywords%% <br>
</strong>The keywords of the link. </p>

<p align="left"><strong>%%name%% <br>
</strong>Name of the submitter. </p>

<p align="left"><strong>%%email%% </strong><br>
Email of the submitter. </p>

<p><strong>%%date%% <br>
</strong>The date when the new submission has been made. </p>

<p><strong>%%category_submitted%% <br>
</strong>The category where the link has been submitted. </p>

<p>$rating_code </p>

<p>$extradfk </p>

]);





print <<END_OF_EDW;

<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>

<body>

$hbox


<form method="POST" action="$admin_url/admin24.cgi">
  <input type="hidden" name="f" value="$filename"><input type="hidden" name="s" value="$s"><input
  type="hidden" name="fct" value="save_email"><input type="hidden" name="from" value="$from"><p>$exp_email_crit
  </p>
  <table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
    <tr>
      <td width="100%" colspan="2" bgcolor="#FFFFFF" class="normaltext"
      background="$web_url/bar6.gif"><strong>Email Details:</strong></td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">$fromnm </td>
      <td width="85%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="from_name"
      size="40" value="$from_name" style="width:100%"> $instr </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">From Email: </td>
      <td width="85%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="from_email"
      size="40" value="$from_email" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">Email Subject: </td>
      <td width="85%" bgcolor="#FFFFFF" class="normaltext"><input type="text"
      name="email_subject" size="57" value="$email_subject" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="15%" valign="top" bgcolor="#FFFFFF" class="normaltext">Message: </td>
      <td width="85%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="24"
      name="email_message" cols="77" style="width:100%">
$email_message
</textarea> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF"></td>
      <td width="85%" bgcolor="#FFFFFF"><input type="submit" value="   Save   " name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>
$helpb

</body>
</html>

END_OF_EDW

#<p align="left"><font face="Verdana" size="1"><strong>%%password%%<br>
#</strong>The password to modify the newly submitted link.</font></p>


}





####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

